
ChiliProject - Feature # 692: new design with 263-new-layout-ready

Status: Closed Priority: Normal
Author: Romano Licker Category: User interface
Created: 2011-11-10 Assignee: Eric Davis
Updated: 2011-12-10 Due date:
Remote issue URL:
Affected version:
Description: The last 3 days I was working on a rebase which combines our current design changes, the changes from 

#263 (@edavis10/263-new-layout-ready@) and the current core chili 2.4.0.

The @edavis10/263-layout-ready@ branch deleted the @common.js@ and moved the content to 
@application.js@. Due to this change and the following changes on @application.js@ it was impossible to 
rebase automatically. I had to rebase manually, identifying the changes in @common.js@ and moving them, 
one by one, into @application.js@.

Since this was very error-prone I had to do it five times - this at least made it easier every single time and I 
believe the current version should be a working one for all of us. The solution now has a linear development 
history making it much easier to understand/read the changes committed. 

I rebased on current unstable and created a pull request. 

In comparison to unstable, the commit contains the following new features:

* login pulldown
* MyName menu (containing MyAccount / Sign Out)
* project autocompleter (using "chosen":http://harvesthq.github.com/chosen/)
* new navigation bar
* project navigation bar with submenus
* new logo
* breadcrumb bar
* overall design changes
** color
** fonts
** widget boxes

Associated revisions
2011-11-13 01:22 am - jwollert 
[#692] change project navigation arrow on hover

- fix project navigation arrows

2011-11-13 01:22 am - Romano Licker
[#692] login slidedown implemented with tabindex and focus fix

2011-11-13 01:22 am - Romano Licker
[#692] images for new design

2011-11-13 01:22 am - Romano Licker
[#692] Main design changes for new theme

2011-11-13 01:22 am - jwollert 
[#692] enable jump to project box to take options (projects and html)
2011-12-09 10:57 pm - jwollert 
[#692] fixes IE7 overflow bug in project search results

2011-12-09 11:03 pm - Romano Licker
[#692] renamed div#account to div#header cleanup

2011-12-09 11:04 pm - Romano Licker
[#692] removes div#admin-menu - now content of main menu

2011-12-10 03:06 am - Romano Licker
[#692] fixes admin-menu
new design on ticket view
filter / options / attachments fieldset redesign

2011-12-10 03:06 am - Romano Licker
[#692] header-menu subentries closer together
2 columns instead of 3 for issue detail

2011-12-10 03:06 am - jwollert 
[#692] remove duplicate header from the bottom of the ticket show view

2011-12-10 03:06 am - Romano Licker
[#692] implemented widget design for mypage

- background gradient image missing
- made icon grey in order to keep it visible
- raised icon margin to position it directly inside the
  widget when in personalize mode
- added a background image to display the gradient

2011-12-10 03:06 am - Eric Davis
[#692] Fix syntax errors and undefined methods in layout from merge

2011-12-10 03:06 am - Eric Davis
[#692] Update CSS by reviewing pre and post-merge diff

2011-12-10 03:06 am - Eric Davis
[#692] Fix failing test due to design changes

2011-12-10 03:06 am - Eric Davis
[#692] Cleanup layout structure from rebase

2011-12-10 04:04 am - Eric Davis
[#692] Fix and simplify the top menu open/closing

* Remove bunch of extra code from choosen
* Fix awkward indention
* Add admin menu items to the Modules menu
* Turn off bold on menu item hover, was causing jumping in width
* Fix color on opened top menus
* Fix a bunch of edge cases in the menu clicks.
* Remove gross 'html' binding in favor of a one time only one
2011-12-10 04:04 am - Eric Davis
[#692] Add register link back into the top menu

2011-12-10 04:04 am - Eric Davis
[#692] Use text based logo

2011-12-10 04:04 am - Eric Davis
[#692] Remove selected gradient from context menu tables

2011-12-10 04:04 am - Eric Davis
[#692] Fix the context menu styles

It was conflicting with S&P theme styles due to the CSS load order,
reset them back to the pre-S&P theme style.

2011-12-10 04:04 am - Eric Davis
[#692] Fix issue history styles

2011-12-10 04:04 am - Eric Davis
[#692] Fix image names

2011-12-10 04:26 am - Eric Davis
[#692] Add missing closing tag

2011-12-10 08:30 pm - Eric Davis
[#692] Make breadcrumbs larger and not completely underlined

2011-12-10 08:35 pm - Eric Davis
[#692] Use i18n label for the More menu

2011-12-10 09:16 pm - Eric Davis
[#692] Add some style to issue action menus

2011-12-10 09:21 pm - Eric Davis
[#692] i18n English string in view

2011-12-10 09:22 pm - Eric Davis
[#692] Update the style of the issue show page to be cleaner

History
2011-11-10 04:44 pm - Romano Licker
Working on it right now. We will post the pull request tomorrow.

2011-11-10 05:47 pm - Eric Davis
Romano Licker wrote:
> The last 3 days I was working on a rebase which combines our current design changes, the changes from #263 
(@edavis10/263-new-layout-ready@) and the current core chili 2.4.0.

Make sure you are targeting 3.0.0 (unstable) and not 2.x (master).

2011-11-11 12:58 pm - Romano Licker
This is it - finally :)

2020-10-25 3/7



Since we ran into more problems rebasing against current unstable, we decided to merge. 
Comparatively it is quite manageable than anything else.

https://github.com/chiliproject/chiliproject/pull/121

2011-11-11 01:09 pm - Holger Just
Yay, finally! This is a huge step forward into the us having the next awesome design.

We have spend way more time than initially planned to bring the patches to the current unstable branch. I think we have to reduce that time for future 
patches, let's talk at the next team meeting what went wrong and how we can improve our process and communication. The merges and rebase 
attempts were a serious PITA and I wouldn't want to do something like this again (and don't wish that anyone else too).

So here's my plan for review. I think we are now beyond the point that many of the changes in the pull can be changed inplace. So I propose we review 
it and do any required changes on top of the unchanged pull. So any found changes should be handled in additional issues and be implemented 
separately. That way we can move to a simpler and more structured approach again.

2011-11-11 07:35 pm - Eric Davis
Romano Licker wrote:
> Since we ran into more problems rebasing against current unstable, we decided to merge. 

Thanks for updating this. Merging it like this is going to make it hard to review. (below)

Holger Just wrote:
> We have spend way more time than initially planned to bring the patches to the current unstable branch.

> I think we have to reduce that time for future patches, let's talk at the next team meeting what went wrong and how we can improve our process and 
communication. The merges and rebase attempts were a serious PITA and I wouldn't want to do something like this again (and don't wish that anyone 
else too).

This is off-topic for this issue and given that this issue is going to have a complex discussion, I've moved this to the 
"forum":https://www.chiliproject.org/boards/2/topics/961.

> So here's my plan for review. I think we are now beyond the point that many of the changes in the pull can be changed inplace. So I propose we 
review it and do any required changes on top of the unchanged pull. So any found changes should be handled in additional issues and be implemented 
separately. That way we can move to a simpler and more structured approach again.

-1 Looking at the commits I'm going to say no. I see several commits that duplicate existing commits (91214e195f0929f5), some commits in German (I 
think), and a few reverting previous code. The history of this branch is extremely confusing at this point, will be difficult to review, and will hurt the code 
history.

If someone isn't willing to do a rebase of this on top of unstable, could someone do an internal rebase at least? Where only the commits in the branch 
are rebased in order to:

* remove the code and the reverting commits (e.g. commits: A, B, C, revert B would become: A, C)
* translate and update the commit logs to be descriptive of *why* a commit is needed and not *how* or *what* a commit is
* squash related commits into one commit

2011-11-12 06:38 pm - Eric Davis
- Assignee changed from Romano Licker to Eric Davis

I'm starting to rebase and squash this branch with Holger's and Felix's help. I'll post here when the code is ready for review.
2011-11-12 09:44 pm - Eric Davis
I've been working on this in the pull request and adding comments to it as I go. Basically I'm taking Romano's pull request, rebasing it onto unstable to 
remove the merge commits, and doing a squash rebase to consolidate the 83 commits into logical chunks that can be committed.

https://github.com/chiliproject/chiliproject/pull/121

2011-11-13 12:36 am - Eric Davis
- Status changed from Open to Ready for review

I've just sent in a "pull request":https://github.com/chiliproject/chiliproject/pull/122 with the results of my rebasing:

* fix unclear commit logs and add the issue prefixes
* remove merge commits from other branches
* reorder commits into logically sequence (see this "gist":https://gist.github.com/1361097 for one version)
* squashing related commits into a single larger commit
* removing unnecessary reverts

I've also done a manual diff of the layout, application.css, and application.js to pull request 121 to make sure nothing major was missed.

Since there is so much here, lets try to keep the code review in this issue. We should review this like so:

# should each commit be included or not?
# for code changes as a whole, is each line acceptable (security, code standards, etc)
# does the changes make sense? Like is this a good change or should it be different.

Eric Davis

2011-11-14 02:03 am - Eric Davis
I started a wiki page ([[692_Layout]]) to track all of my feedback. The design review is complete and I'll work on the code and feature review next. 

Feel free to add sections for your own reviews and then we can go over everything at once and decide how to proceed.

2011-11-14 06:22 am - Felix Schäfer
Eric Davis wrote:
> I started a wiki page ([[692_Layout]]) to track all of my feedback. The design review is complete and I'll work on the code and feature review next. 
> 
> Feel free to add sections for your own reviews and then we can go over everything at once and decide how to proceed.

Wasn't sure how to add my comments to your feedback, I've added them as lower-level list points.

2011-11-14 04:07 pm - Romano Licker
I fixed two minor bugs. One broke themes of ours.

https://github.com/edavis10/chiliproject/pull/1

2011-11-14 04:35 pm - Eric Davis
Felix SchÃ¤fer wrote:
> Wasn't sure how to add my comments to your feedback, I've added them as lower-level list points.

I guess that is fine. I was hoping everyone would review the design themselves adding their own comments (i.e. append only) and then as a group we 
would go through them and decide what to do.
2011-11-15 06:30 pm - Eric Davis
I'm changing my mind; using the wiki page for discussion is becoming a mess. Lets keep all discussion of the features and bugs in this issue (or other 
issues if relevant) and only use the wiki page for listing what everyone has found.

2011-11-15 07:43 pm - Niels Lindenthal
Eric Davis wrote:
> I'm changing my mind; using the wiki page for discussion is becoming a mess. Lets keep all discussion of the features and bugs in this issue (or other 
issues if relevant) and only use the wiki page for listing what everyone has found.

What do you mean by that? Do you want to use the wiki to track issues?

2011-11-15 08:33 pm - Eric Davis
Niels Lindenthal wrote:
> Do you want to use the wiki to track issues?

That's close to what I meant. I intended the wiki page to be used as a record to collect each persons' feedback as they test the new code. Things like 
bugs, usability problems, or things that need to be changed. Then, as a group, we would review them all and decide what to do with each one in the 
issue (e.g. fix now, create issue and fix later, ignore, etc).

Recent edits to that page have been more about discussing the things already listed there (which is better done in this issue once everyone has done 
their review). This is making the page a mess and difficult to understand.

Roughly the steps are:

# People review the changes individually
# As a group, each thing is discussed and duplicates consolidated if multiple people found the same thing
# As a group, decisions made on what to do for each item
# Actions taken based on the decisions

(This is the same as how all proposed changes are done, though smaller changes move faster since there is less impact than a full redesign)

2011-11-27 06:15 pm - Felix Schäfer
I've added my comments to the pull request and to the wiki page, not much more to add to Eric's points though.

2011-12-01 11:14 pm - Eric Davis
Thanks Felix, I've reviewed your comments in the wiki and the pull request. At this point I think it's safe to close this issue for review since there have 
been almost 3 weeks.

I'm going to try to summarize the issues found and propose some decisions next.

2011-12-01 11:47 pm - Eric Davis
Okay, I've gone through the notes on the wiki and the pull request and summarized everything.

On the top of the wiki ([[692_Layout]]) is the summary with my opinion of what each feature/part would fall under: blocks the release, would be nice to 
have but not required, or wait until later.

Does anyone have any feedback on:

# The "status" of each item? (e.g. blocker, later)
# The decision of each item?
You can add your feedback under the item with your name or discuss it here.

The sooner we can reach an agreement, the sooner I can update the pull request, and the soon we can finish this issue up (and get 3.0 released). 
Thinking 3-4 days to get final feedback should be enough time.

It's been a long feature but we're getting close to the end now.

2011-12-09 09:07 pm - Eric Davis
I'm going to assume that silence on this issue means an agreement. Since this feature is blocking 3.0 and we are already dangerously close to missing 
our release dates I'm going to take some drastic actions:

* I've scheduled some time this weekend to work on this
* I'll be fixing the most critical problems with this code
* I'll be merging that code into unstable
* For things I am not able to fix, I'll be ripping out functionality with the explicit goal of getting this code into a working state (expect hacks, workarounds, 
and lots of cursing... ;) )

Once that is done then it will be time to finish or push back on the last 3.0 features and release a beta. Any and all bugs can then be handles post 
3.0-beta or in minor releases (3.1.0, 3.2.0, etc).

2011-12-10 12:36 am - Eric Davis
- Status changed from Ready for review to Open

Did a lot of work on the blocker items, specifically around the projects menu. Will continue tomorrow, rebase, and commit. 

2011-12-10 07:02 pm - Eric Davis
- Status changed from Open to Closed

I've fixed all of the Blocker issues listed on the [[692_Layout|wiki page]] except for one that needs to be discussed first. I'm going to create an issue for 
that one and then either fix or create issues for the rest of the items.

Thanks to everyone who contributed code, designs, ideas, and helped with this new design. It will be a great step forward for ChiliProject and will make 
future usability improvements easier.
